/*
 * Copyright (C) 2011 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package android.system;

import java.net.InetAddress;
import libcore.util.Objects;

/**
 * Corresponds to C's {@code struct group_req}.
 *
 * @hide
 */
public final class StructGroupReq {
  public final int gr_interface;
  public final InetAddress gr_group;

  public StructGroupReq(int gr_interface, InetAddress gr_group) {
    this.gr_interface = gr_interface;
    this.gr_group = gr_group;
  }

  @Override public String toString() {
    return Objects.toString(this);
  }
}
